using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page
{
    const string COOKIE_NAME = "TestCookie";
    const string COOKIE_VALUE = "Green";
    
    protected void Page_Load(object sender, EventArgs e)
    {
        ((MyMasterPage)Master).SetTitles("Cookie Lab", "Experiment with Cookies");

        displayCookie();
        //lblRandomKey.Text = TamperDetector.GenerateRandomKey();
    }

    protected void btnSetCookie_Click(object sender, EventArgs e) {
        writeCookie(COOKIE_VALUE);
        Response.Redirect(Request.Path);
    }

    protected void btnClearCookie_Click(object sender, EventArgs e) {
        writeCookie(null);
        Response.Redirect(Request.Path);
    }

    void displayCookie() {
        try {
            string cookieValue = readCookie();

            if (null == cookieValue) {
                lblCookieInfo.Text = "No cookie was found.";
            }
            else {
                // Note that there is an XSS vulnerability here.
                // The user can change the contents of any cookie!
                lblCookieInfo.Text = "Cookie found: " + cookieValue;
            }
        }
        catch (DataTamperingException) {
            lblCookieInfo.Text = "Cookie has been tampered with or corrupted!";
        }
    }

    string readCookie() {
        HttpCookie cookie = Request.Cookies.Get(COOKIE_NAME);
        if (null == cookie) {
            return null; // cookie not present
        }
        else {
            return TamperDetector.CheckAndRemoveTamperDetection(cookie.Value);
        }
    }

    void writeCookie(string value) {
        HttpCookie cookie = new HttpCookie(COOKIE_NAME);

        if (null == value) {
            // delete the cookie
            cookie.Expires = DateTime.Now.AddDays(-50.0);
        }
        else {
            cookie.Expires = DateTime.Now.AddDays(50.0);
            cookie.Value = TamperDetector.AddTamperDetection(value);
        }
        Response.Cookies.Add(cookie);
    }
}
